Croxit
======
*WebView for mobile platforms on steroids*

## What is Croxit?
Croxit is a cross-platform Web View implementation for mobile and Dektop platforms for **Haxe**. It's intended to easily provide the deployment of rich interfaces in a cross-platform environment, like *PhoneGap* (Apache Cordova), but with plenty of advantages

## Why should I use it?
If you need to create rich user interfaces that must work on a cross platform way with ease, your best bet is to use HTML5. Croxit provides the base for it. If you are a web developer, Croxit provides not only a familiar way to write applications (client/server based), but it provides a fully functional environment to be able to deploy **the very same code** in both a web server and a local mobile self-contained version.

## What are the advantages?
Well, first of all, it's written in **Haxe** :-)

 * **It's native:** leverage native performances and be free to implement native interoperabilities without the hassle (and sometimes prohibitive cost) of object serialization.
 * **Write application code just like you would write a website:** Would you write a SQL query in a real world Web App in JavaScript? Or would you manipulate an image in wasteful base64 encoding just to write it to disk? Then don't do it on a mobile device! Croxit allows you, the developer, to write applications just like a website. In fact, did we say that **you can compile to both a web server and to a mobile target with the SAME code base** ?
 * **NME integration:** Okay, so you're writing your application in HTML5 because interface is so much easier there. But what if you need to leverage some cool graphics? What if you need to use the GPU's true power? Don't waste countless hours trying to optimize it in JavaScript! Use its **NME** integration, achieve **native** performances, and write it like you would in a normal webpage (with js/server/flash) !

## Supported platforms
Right now, we are in early alpha, and the only supported mobile platform is iOs. An Android version is on the way using Haxe's Java target, and a desktop version with Webkit is on its way as well!

Read the code examples, and get coding! :)

This awesome lib is brought to you by http://www.braincorps.com.br and http://www.comtacti.com.br

## Known issues
 * As a platform limitation of iOs WebView, **there can't be any absolute paths** in your code. The issue is that we're on file:// namespace, so absolute paths will refer to iOs' own root
